#(C) Optibrium 2010
#This script allows an administrator to check the users currently logged in to the StarDrop License Server
#and log them off if required. 

import xmlrpclib
import os
import imp
import copy
import time

from xml.dom import minidom

map = {}

PRODUCT = 'StarDrop'

try:
  import sls_usermap
  map = sls_usermap.userIds
except:
  pass

def parseKeyInfo(xml):
  keys = []
  doc = minidom.parseString(xml).documentElement
  #lic = doc.getElementsByTagName('licenses')[0]
  entries = doc.getElementsByTagName('license')
  for f in entries:
    val = int(f.getAttribute('features'))
    keys.append(val)
  return keys

def logOffUser(user,server,keys):
  t = time.time()
  done = False
  i = 0
  while done == False and i < len(keys):
    resp = server.releaseLicense(user,keys[i],t)
    if resp != -1:
      print u + ' logged off'
      done = True
    i = i + 1
  if done != True:
    print 'log off failed'


if __name__ == "__main__":
    #get the server address to instantiate the proxy
    if os.name == 'posix':
        vars = imp.load_module('SimpleConfig',open('/etc/sysconfig/' + PRODUCT + 'LicenseServer_conf.py'),'/etc/sysconfig/' + PRODUCT + 'LicenseServer_conf.py',('.py','r',1))
    else:
        vars = imp.load_module('SimpleConfig',open(PRODUCT + 'LicenseServer_conf.py'),PRODUCT + 'LicenseServer_conf.py',('.py','r',1))

    serverAddr  = copy.copy(vars.serverURI) # Get the address


    try:
        server = xmlrpclib.ServerProxy(serverAddr)

        users = server.displayUsers()
        keyinfo = server.displayKeys()
    except:
	print 'No server found'
	os._exit(-1)

    print 'There are ' + `len(users)` + ' users currently logged in'

    if len(users) > 0:
      keys = parseKeyInfo(keyinfo)
      print 'Users:'

    for u in users:
      if map.has_key(u):
        name = map[u]
      else:
        name = u
      lo = raw_input('Log ' + name + ' off? (y/n)')
      if lo in ('y', 'Y', 'yes','Yes','YES'):
         logOffUser(u,server,keys)
      elif lo in ('n', 'N', 'no','No','NO'):
        pass
      else:
        print 'Invalid response - ignoring'
        
